package cn.minbb.InterfaceTest.ctrl;

import android.annotation.SuppressLint;
import android.app.Application;
import android.content.Context;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.view.ViewGroup;

import com.android.volley.RequestQueue;
import com.android.volley.toolbox.Volley;
import com.joanzapata.iconify.Iconify;
import com.joanzapata.iconify.fonts.FontAwesomeModule;

import java.text.SimpleDateFormat;
import java.util.Date;

import cn.minbb.InterfaceTest.R;

public class App extends Application {

    // 全局上下文
    private Context context = null;
    // Volley 网络请求队列
    private static RequestQueue requestQueue;
    // 时间格式
    private static SimpleDateFormat simpleDateFormat = (SimpleDateFormat) SimpleDateFormat.getDateTimeInstance();

    public App() {
    }

    @SuppressLint("StaticFieldLeak")
    private static App app = null;

    public static App getApp() {
        return app;
    }

    @Override
    public void onCreate() {
        super.onCreate();
        app = this;
        context = getApplicationContext();

        // 初始化 Volley 网络请求队列
        requestQueue = Volley.newRequestQueue(context);
        // 初始化字体图标模块
        Iconify.with(new FontAwesomeModule());
    }

    @Override
    public void onTerminate() {
        super.onTerminate();
    }

    public static RequestQueue getRequestQueue() {
        return requestQueue;
    }

    // 获取系统当前时间
    public static String getCurrentStringTime() {
        return simpleDateFormat.format(getCurrentDateTime());
    }

    public static Date getCurrentDateTime() {
        return new Date();
    }

    public Context getContext() {
        return context;
    }

    // 设置 ActionBar
    public static void setupActionBar(AppCompatActivity appCompatActivity) {
        // id from appcompat
        ViewGroup rootView = appCompatActivity.findViewById(R.id.action_bar_root);
        if (rootView != null) {
            View view = appCompatActivity.getLayoutInflater().inflate(R.layout.app_bar_layout, rootView, false);
            rootView.addView(view, 0);

            Toolbar toolbar = appCompatActivity.findViewById(R.id.toolbar);
            appCompatActivity.setSupportActionBar(toolbar);
        }

        ActionBar actionBar = appCompatActivity.getSupportActionBar();
        if (actionBar != null) {
            // 在 ActionBar 中显示 UP 按钮。
            actionBar.setDisplayHomeAsUpEnabled(true);
        }
    }
}
