package cn.minbb.InterfaceTest.views;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.constraint.ConstraintLayout;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TextInputEditText;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.app.AppCompatDelegate;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.RadioButton;

import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;

import java.io.IOException;

import butterknife.BindView;
import butterknife.ButterKnife;
import cn.minbb.InterfaceTest.R;
import cn.minbb.InterfaceTest.ctrl.App;
import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.OkHttpClient;
import okhttp3.Request;

public class MainActivity extends AppCompatActivity {

    @BindView(R.id.main)
    ConstraintLayout main;
    @BindView(R.id.volley)
    RadioButton volley;
    @BindView(R.id.okhttp)
    RadioButton okhttp;
    @BindView(R.id.userAccount)
    TextInputEditText userAccount;
    @BindView(R.id.flag1)
    TextInputEditText flag1;
    @BindView(R.id.yuliu1)
    TextInputEditText yuliu1;
    @BindView(R.id.yuliu2)
    TextInputEditText yuliu2;

    static {
        AppCompatDelegate.setCompatVectorFromResourcesEnabled(true);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);

        App.setupActionBar(this);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        App.getRequestQueue().cancelAll("request");
    }

    public static void start(Context context) {
        Intent starter = new Intent(context, MainActivity.class);
        context.startActivity(starter);
    }

    public void onViewClick(View view) {
        String url = "http://218.28.14.168:8080/TKRCS/Receiptimglist/aduploading.do?userAccount=" + userAccount.getText().toString() + "&flag1=" + flag1.getText().toString() + "&yuliu1=" + yuliu1.getText().toString() + "&yuliu2=" + yuliu2.getText().toString();
        if (volley.isChecked()) {
            StringRequest request = new StringRequest(
                    url,
                    new Response.Listener<String>() {
                        @Override
                        public void onResponse(String s) {
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    ScrollingActivity.start(MainActivity.this, s);
                                }
                            });
                        }
                    },
                    new Response.ErrorListener() {
                        @Override
                        public void onErrorResponse(VolleyError volleyError) {
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    Snackbar.make(main, "请求失败，请重试！", Snackbar.LENGTH_SHORT).show();
                                }
                            });
                        }
                    });
            request.setTag("request");
            App.getRequestQueue().add(request);
        } else if (okhttp.isChecked()) {
            Request request = new Request.Builder().url(url).build();
            new OkHttpClient().newCall(request).enqueue(new Callback() {
                @Override
                public void onFailure(Call call, IOException e) {
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            Snackbar.make(main, "请求失败，请重试！", Snackbar.LENGTH_SHORT).show();
                        }
                    });
                }

                @Override
                public void onResponse(Call call, okhttp3.Response response) throws IOException {
                    ScrollingActivity.start(MainActivity.this, response.body().string());
                }
            });
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                MainActivity.this.finish();
                break;
            default:
        }
        return super.onOptionsItemSelected(item);
    }
}
