package cn.minbb.InterfaceTest.views;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.app.AppCompatDelegate;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.CycleInterpolator;
import android.view.animation.TranslateAnimation;
import android.widget.CheckBox;
import android.widget.CompoundButton;

import com.android.volley.Request;
import com.android.volley.toolbox.JsonObjectRequest;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import cn.minbb.InterfaceTest.R;
import cn.minbb.InterfaceTest.controls.ClearTextInputEditText;
import cn.minbb.InterfaceTest.ctrl.App;

public class RegisterActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {

    @BindView(R.id.toolbar)
    Toolbar toolbar;
    @BindView(R.id.userAccount)
    ClearTextInputEditText userAccount;
    @BindView(R.id.userName)
    ClearTextInputEditText userName;
    @BindView(R.id.userSex)
    ClearTextInputEditText userSex;
    @BindView(R.id.userPassword)
    ClearTextInputEditText userPassword;
    @BindView(R.id.userPasswordRepeat)
    ClearTextInputEditText userPasswordRepeat;
    @BindView(R.id.userPassportno)
    ClearTextInputEditText userPassportno;
    @BindView(R.id.userPassportnotime)
    ClearTextInputEditText userPassportnotime;
    @BindView(R.id.userPhonenum)
    ClearTextInputEditText userPhonenum;
    @BindView(R.id.vCode)
    ClearTextInputEditText vCode;
    @BindView(R.id.userDef4)
    ClearTextInputEditText userDef4;
    @BindView(R.id.userDef5)
    ClearTextInputEditText userDef5;
    @BindView(R.id.userDef6)
    ClearTextInputEditText userDef6;
    @BindView(R.id.userDef8)
    ClearTextInputEditText userDef8;
    @BindView(R.id.alreadyRead)
    CheckBox alreadyRead;

    private boolean alreadyReadIsChecked = false;
    private ProgressDialog dialog;

    static {
        AppCompatDelegate.setCompatVectorFromResourcesEnabled(true);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_register);
        ButterKnife.bind(this);

        initView();
        setListener();
        loadData();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        App.getRequestQueue().cancelAll("register");
        if (dialog != null && dialog.isShowing()) {
            dialog.dismiss();
        }
    }

    public static void start(Context context) {
        context.startActivity(new Intent(context, RegisterActivity.class));
    }

    private void initView() {
        toolbar.setNavigationIcon(R.drawable.ic_arrow_back_white_24dp);
        setSupportActionBar(toolbar);
    }

    private void setListener() {
        alreadyRead.setOnCheckedChangeListener(this);
    }

    private void loadData() {
    }

    private void attemptRegister() {
        // 重置错误为空
        userAccount.setError(null);
        userName.setError(null);
        userSex.setError(null);
        userPassword.setError(null);
        userPasswordRepeat.setError(null);
        userPassportno.setError(null);
        userPassportnotime.setError(null);
        userPhonenum.setError(null);
        vCode.setError(null);
        userDef4.setError(null);
        userDef5.setError(null);
        userDef6.setError(null);
        userDef8.setError(null);

        // 获取登录表单账号与密码
        String userAccountText = userAccount.getText().toString();
        String userNameText = userName.getText().toString();
        String userSexText = userSex.getText().toString();
        String userPasswordText = userPassword.getText().toString();
        String userPasswordRepeatText = userPasswordRepeat.getText().toString();
        String userPassportnoText = userPassportno.getText().toString();
        String userPassportnotimeText = userPassportnotime.getText().toString();
        String userPhonenumText = userPhonenum.getText().toString();
        String vCodeText = vCode.getText().toString();
        String userDef4Text = userDef4.getText().toString();
        String userDef5Text = userDef5.getText().toString();
        String userDef6Text = userDef6.getText().toString();
        String userDef8Text = userDef8.getText().toString();

        boolean cancel = false;
        View focusView = null;

        // 已阅用户须知
        if (!alreadyReadIsChecked) {
            focusView = alreadyRead;
            cancel = true;
            Snackbar.make(toolbar.getRootView(), "请先阅读用户须知", Snackbar.LENGTH_SHORT).show();
        }

        // 检查 出生年月日 是否有效
        if (TextUtils.isEmpty(userDef4Text)) {
            userDef4.setError("出生年月日不能为空");
            focusView = userDef4;
            cancel = true;
        }

        // 检查 短信验证码 是否有效
        if (TextUtils.isEmpty(vCodeText)) {
            vCode.setError("短信验证码不能为空");
            focusView = vCode;
            cancel = true;
        }

        // 检查 用户电话 是否有效
        if (TextUtils.isEmpty(userPhonenumText)) {
            userPhonenum.setError("用户电话不能为空");
            focusView = userPhonenum;
            cancel = true;
        }

        // 检查 护照有效期 是否有效
        if (TextUtils.isEmpty(userPassportnotimeText)) {
            userPassportnotime.setError("护照有效期不能为空");
            focusView = userPassportnotime;
            cancel = true;
        }

        // 检查 用户护照号 是否有效
        if (TextUtils.isEmpty(userPassportnoText)) {
            userPassportno.setError("用户护照号不能为空");
            focusView = userPassportno;
            cancel = true;
        }

        // 检查 用户密码 是否有效
        if (TextUtils.isEmpty(userPasswordText) || !isUserPasswordValid(userPasswordText)) {
            userPassword.setError("用户密码不能为空");
            focusView = userPassword;
            cancel = true;
        } else if (!userPasswordText.equals(userPasswordRepeatText)) {
            userPasswordRepeat.setError("两次输入的密码不一致");
            focusView = userPasswordRepeat;
            cancel = true;
        }

        // 检查 用户性别 是否有效
        if (TextUtils.isEmpty(userSexText)) {
            userSex.setError("用户性别不能为空");
            focusView = userSex;
            cancel = true;
        }

        // 检查 用户全拼姓名 是否有效
        if (TextUtils.isEmpty(userNameText)) {
            userName.setError("用户全拼姓名不能为空");
            focusView = userName;
            cancel = true;
        }

        // 检查 用户账号 是否有效
        if (TextUtils.isEmpty(userAccountText) || !isUsernameValid(userAccountText)) {
            userAccount.setError("用户账号不能为空(不符合规则)");
            focusView = userAccount;
            cancel = true;
        }

        if (cancel) {
            assert focusView != null;
            focusView.requestFocus();
            Animation translateAnimation = new TranslateAnimation(0, 10, 0, 0);
            translateAnimation.setInterpolator(new CycleInterpolator(5));
            translateAnimation.setDuration(1000);
            focusView.setAnimation(translateAnimation);
        } else {
            showProgress(true);
            toRegister(userAccountText, userNameText, userSexText, userPasswordText, userPassportnoText, userPassportnotimeText, userPhonenumText, vCodeText, userDef4Text, userDef5Text, userDef6Text, userDef8Text);
        }
    }

    private boolean isUserPasswordValid(String passwordText) {
        int length = passwordText.length();
        return length >= 0;
    }

    private boolean isUsernameValid(String usernameText) {
        return usernameText.length() >= 1;
    }

    private void showProgress(boolean show) {
        if (dialog == null) {
            dialog = new ProgressDialog(this);
            dialog.setTitle("用户注册");
            dialog.setMessage("注册中······");
            dialog.setCancelable(false);
        }
        if (show) {
            dialog.show();
        } else {
            dialog.dismiss();
        }
    }

    private void toRegister(String userAccountText, String userNameText, String userSexText, String userPasswordText, String userPassportnoText, String userPassportnotimeText, String userPhonenumText, String vCodeText, String userDef4Text, String userDef5Text, String userDef6Text, String userDef8Text) {
        JsonObjectRequest registerRequest = new JsonObjectRequest(
                Request.Method.GET,
                "http://218.28.14.168:8080/TKRCS/register.do?userAccount=" + userAccountText + "&userName=" + userNameText + "&userSex=" + userSexText + "&userPassword=" + userPasswordText + "&userPassportno=" + userPassportnoText + "&userPassportnotime=" + userPassportnotimeText + "&userPhonenum=" + userPhonenumText + "&vCode=" + vCodeText + "&userDef4=" + userDef4Text + "&userDef5=" + userDef5Text + "&userDef6=" + userDef6Text + "&userDef8=" + userDef8Text,
                null,
                jsonObject -> {
                    showProgress(false);
                    com.alibaba.fastjson.JSONObject json = com.alibaba.fastjson.JSONObject.parseObject(jsonObject.toString());
                    System.out.println("json = " + json.toJSONString());
                    ScrollingActivity.start(RegisterActivity.this, json.toJSONString());
                    RegisterActivity.this.finish();
                },
                volleyError -> {
                    showProgress(false);
                    Snackbar.make(toolbar.getRootView(), "注册失败，请稍后重试！", Snackbar.LENGTH_SHORT).show();
                });
        registerRequest.setTag("register");
        App.getRequestQueue().add(registerRequest);
    }

    @OnClick({R.id.userInstructions, R.id.register})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.userInstructions:
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle("用户须知")
                        .setMessage("(*)号标识为必填项。")
                        .setPositiveButton("同意", (dialog, which) -> {
                            alreadyRead.setChecked(true);
                        })
                        .setNegativeButton("不同意", (dialog, which) -> {
                            alreadyRead.setChecked(false);
                        })
                        .setCancelable(false).create().show();
                break;
            case R.id.register:
                attemptRegister();
                break;
        }
    }

    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        if (buttonView.getId() == R.id.alreadyRead) {
            alreadyReadIsChecked = isChecked;
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                break;
            default:
        }
        return super.onOptionsItemSelected(item);
    }
}
